/*
cidrxDataSt.h
*/
//#include "../include/CidRxCon.h"
//#include "Typedef.h"
#if CID_RX_DET
typedef struct{	           
               /*
			       User CLI Configuration parameter.                   
				   1. Bellcore  --> Default.
				   2. ETSI
				   3. NTT
			   */
			   Word16  CidrxComplainVer; 

		       /*
			    Run Time Decoded Data layer parameter.
				-1. Not yet arrived this parameter.
                 1. Mdmf
				 2. Sdmf
			   */
               Word16  MsgTypeFlag;    
			   Word16  MsgLenFlag;
			   /*  Run Time Decoded Data layer parameter.
				-1. Not yet arrived this parameter.
				> 0. is valid length.
			   */
			   Word16  MsgLen;  
			   Word16 MsgLenRun;
   
               //---> TIME FIELD.
			   Word16 TimeFlag;
			   Word16 TimeRunLen;
               Word16 TimeLen;

			   CHAR Month[2];   //--> 1 to 12
			   CHAR Day[2];     //--> 01-31
			   CHAR Hour[2];    //--> 00-23
			   CHAR Minute[2];  //--> 00-59
			   
               /*    Name Flag or FlagN
			         -1. Not yet arrived.
				  0. Lng of msg detection.
				  1. Msg of name detection
			   */

			   Word16  NameFlag;     
			   Word16  NameFlagN;     
			   /*
			       Name Len : 0 Default
				            > 0 
			   */
                           Word16  NameLen;
			   Word16  NameRunLen;
			   CHAR Name[80];          // 50 max in reality

			   /*    Number Flag or FlagN
			         -1. Not yet arrived.
			          0. Lng of msg detection.
			          1. Msg of number detection
			   */
			   Word16  NumberFlag;     //--> Num avail
			   Word16  NumberFlagN;    //--> Num /non avail/confidentail
			   /*
			       Number Len : 0 Default
				              > 0 
			   */
			   Word16  NumberLen;
			   Word16  NumberRunLen;
                           CHAR Number[80];	   // 18 max in reality

//-----------------------------------------------
			   /*    Number of First Calling Flag
			         -1. Not yet arrived.
			          0. Lng of msg detection.
			          1. Msg of number detection
			   */
			   Word16  NumberFirstFlag;    
			   /*
			       Number Len : 0 Default
				              > 0 
			   */
			   Word16  NumberFirstLen;
			   Word16  NumberFirstRunLen;
                           CHAR NumberFirst[80];	   // 18 max in reality

//-----
			   /*    Call transfert type
			         -1. Not yet arrived.
			          0. Lng of msg detection.
			          1. Msg of number detection
			   */
			   Word16  CallTransFlag;    
			   /*
			       Number Len : 0 Default
				              > 0 
			   */
			   Word16  CallTransLen;
			   Word16  CallTransRunLen;
                           CHAR    CallTrans[10];
//-----
			   /*    Ordinary calling subscriber
			         -1. Not yet arrived.
			          0. Lng of msg detection.
			          1. Msg of number detection
			   */
			   Word16  OCSFlag;    
			   /*
			       Number Len : 0 Default
				              > 0 
			   */
			   Word16  OCSLen;
			   Word16  OCSRunLen;
                           CHAR    OCS[10];

//------------------------------------------------
			   /*    Check Error Flag :
			         -1. Not yet cal
					 0. Calculated No Error
					 1. Calculated Error in CheckSum.
			   */
			   //UCHAR  CheckSumRx;
               		   // UCHAR  CheckSumExp;
				//char  CheckSumRx;
				//char  CheckSumExp;

                             Word16  CheckSumRx;
                             Word16  CheckSumExp;

			   Word16 CheckSumErrFlag; 
			   Word16 CheckSumRun;

			   Word16 Done;
			   Word16 PrevRdIndex;

//-------------------------------- generic structure for undecode msg
			   /*    Flag
			         -1. Not yet arrived.
			          0. Lng of msg detection.
			          1. Msg of number detection
			   */
			   Word16  Unused_Flag;    
			   /*
			       Number Len : 0 Default
				              > 0 
			   */
			   Word16  Unused_Len;
			   Word16  Unused_RunLen;
                           CHAR Unused_[80];

           }cidrx_st_;
#endif
