#include <oswrapper.h>

#include "ToneGenCons.h"
#include <voicelib.h>
FOURCADENCE_TONE_TYPE ToneParams[2];
extern Word16 SMM_OldToneEvtFlag[];
extern Word16 SMM_ToneEvtFlag[];
extern Word16 SMM_continuousToneFlg[];
extern Word16 SMM_ToneSampleCtr[];
extern Word16 SMM_PauseSampleCtr[];
extern Word16 SMM_ToneGen_Phase1[];
extern Word16 SMM_ToneGen_Phase2[]; 
extern Word16 SMM_ToneGen_Scale1[];
extern Word16 SMM_ToneGen_Scale2[];
extern Word16 SMM_TonePrevSampleCtr[];
extern Word16 SMM_PausePrevSampleCtr[];
extern Word16 SMM_ToneGenState[];

extern Word16 SMM_CadCntr[];
extern Word16 SMM_CadCnt[];
extern Word16 SMM_ToneInit_flag[];
extern Word16 CurChanNum;
extern Word16 SMM_ToneGen_Phasetemp[MAX_VOICE_CHANNELS][2]; 
extern Word16 SMM_bUseGeneric[];
extern Word16 ToneArray[5][50][6];
extern Word16  SMM_ToneGenEna[];



void initCad(Word16 CurChan)
{
  int i;

   //ToneParams[CurChan].ulToneId=NON_CONTINUOUS_TONE;
   ToneParams[CurChan].ulToneId=CONTINUOUS_TONE;
   ToneParams[CurChan].ulCadenceCount=4;
   for (i=0;i<ToneParams[CurChan].ulCadenceCount;i++)
   	{
   ToneParams[CurChan].stCandence[i].ulCadenceOn= ToneArray[4][DIAL_TONE + i][0];
   ToneParams[CurChan].stCandence[i].ulCadenceOff= ToneArray[4][DIAL_TONE + i][1];
   ToneParams[CurChan].stCandence[i].ulCadenceFrq1= ToneArray[4][DIAL_TONE + i][2];
   ToneParams[CurChan].stCandence[i].ulCadenceFrq2= ToneArray[4][DIAL_TONE + i][3];
   ToneParams[CurChan].stCandence[i].ulCadenceAmp1= ToneArray[4][DIAL_TONE + i][4];
   ToneParams[CurChan].stCandence[i].ulCadenceAmp2= ToneArray[4][DIAL_TONE + i][5];
   }
}

void ToneInitGeneral( Word16 CurChan,Word16 ToneType)
{

  FOURCADENCE_TONE_TYPE *pToneParams;

   pToneParams= &ToneParams[CurChan];
    SMM_OldToneEvtFlag[CurChan] = -1;
    SMM_ToneEvtFlag[CurChan] = 0;


    //CurChanNum=CurChan;

	//ToneId should be 2 if it is continous
        SMM_continuousToneFlg[CurChan] = pToneParams->ulToneId;
        SMM_CadCnt[CurChan]=pToneParams->ulCadenceCount;
 
     
       SMM_ToneSampleCtr[CurChan]	     = pToneParams->stCandence[0].ulCadenceOn << 3; //--> ms to Sample Count
	SMM_PauseSampleCtr[CurChan] 	     = pToneParams->stCandence[0].ulCadenceOff<< 3; //--> ms to Sample Count
	SMM_ToneGen_Phase1[CurChan]       = pToneParams->stCandence[0].ulCadenceFrq1;	//Phase1
	SMM_ToneGen_Phase2[CurChan]       = pToneParams->stCandence[0].ulCadenceFrq2; //Phase2
	SMM_ToneGen_Scale1[CurChan]       = pToneParams->stCandence[0].ulCadenceAmp1; //Amp1
	SMM_ToneGen_Scale2[CurChan]       = pToneParams->stCandence[0].ulCadenceAmp2 ; //Amp2
	SMM_TonePrevSampleCtr[CurChan]    = 0; //Counter to maintain Remaining Tone samples
	SMM_PausePrevSampleCtr[CurChan]   = 0; //Counter to maintain Remaining Pause samples
	SMM_ToneGenState[CurChan]	     = INACTIVE; //Initial State
	SMM_ToneGen_Phasetemp[CurChan][0] = 0; //Accumulated Phase of Phase1
	SMM_ToneGen_Phasetemp[CurChan][1] = 0; //Accumulated Phase of Phase2


       
      
#if 0

       SMM_bPha3[CurChanNum]=bPha3;
	SMM_bPha4[CurChanNum]=bPha4;
    if(bPha3 ==1)
    	{
	SMM_ToneGen_Phase3[CurChanNum] 	=   ToneBuffPtr++;
	SMM_ToneGen_Scale3[CurChanNum] 	=   ToneBuffPtr++;
    	}
	else
	ToneBuffPtr+=2;

	if(bPha4 ==1)
    	{
	SMM_ToneGen_Phase4[CurChanNum] 	=   ToneBuffPtr++;
	SMM_ToneGen_Scale4[CurChanNum] 	=   ToneBuffPtr++;
    	}
	else
	ToneBuffPtr+=2;
 #endif

}


void ToneGenGeneral(Word16 CurChan)
{

   Word16 CadNum;
   FOURCADENCE_TONE_TYPE *pToneParams;


      pToneParams= &ToneParams[CurChan];
	  
      if( SMM_ToneInit_flag[CurChan]==1)
      	{
	  	   SMM_ToneInit_flag[CurChan]=0;
      	}
	  else 
	  {

	      //if (SMM_continuousToneFlg[CurChan]!=CONTINUOUS_TONE)
	      //if ((SMM_continuousToneFlg[CurChan]!=CONTINUOUS_TONE) && ( SMM_CadCntr[CurChan]!=SMM_CadCnt[CurChan]))
	      	{

   	  	SMM_CadCntr[CurChan]++;
	  
	 	if( SMM_CadCntr[CurChan]<SMM_CadCnt[CurChan])
	  	{

		  	CadNum=SMM_CadCntr[CurChan];
	  	   
       			SMM_ToneSampleCtr[CurChan]	     = pToneParams->stCandence[CadNum].ulCadenceOn << 3; //--> ms to Sample Count
			SMM_PauseSampleCtr[CurChan] 	     = pToneParams->stCandence[CadNum].ulCadenceOff<< 3; //--> ms to Sample Count
			SMM_ToneGen_Phase1[CurChan]       = pToneParams->stCandence[CadNum].ulCadenceFrq1;	//Phase1
			SMM_ToneGen_Phase2[CurChan]       = pToneParams->stCandence[CadNum].ulCadenceFrq2; //Phase2
			SMM_ToneGen_Scale1[CurChan]       = pToneParams->stCandence[CadNum].ulCadenceAmp1; //Amp1
			SMM_ToneGen_Scale2[CurChan]       = pToneParams->stCandence[CadNum].ulCadenceAmp2 ; //Amp2
			SMM_TonePrevSampleCtr[CurChan]    = 0; //Counter to maintain Remaining Tone samples
			SMM_PausePrevSampleCtr[CurChan]   = 0; //Counter to maintain Remaining Pause samples
			SMM_ToneGenState[CurChan]	     = INACTIVE; //Initial State
			SMM_ToneGen_Phasetemp[CurChan][0] = 0; //Accumulated Phase of Phase1
			SMM_ToneGen_Phasetemp[CurChan][1] = 0; //Accumulated Phase of Phase2
	      
			if(SMM_CadCntr[CurChan]==(SMM_CadCnt[CurChan] -1))
				SMM_continuousToneFlg[CurChan] =pToneParams->ulToneId;

	  	   
	  	}
	       	else
	       	{     if(PLAY_ONLY_ONCE==pToneParams->ulToneId)
	       	      {
                               //Quits Tone after playing once	
                 	  dspipcQuitTone(CurChan, pToneParams->ulToneId);
                 	  	
                      }
                      else
	       	      {
                 	  	SMM_CadCntr[CurChan]=-1;
                 	       
                      }
	       	}
	  }
	}

	
}

