/********************************************************************
Ver       : 0.06
File Name : CIDTxVar.h
Purpose   : Declaration of data structures for Caller-ID Generation.
Project   : To generate CID CP-FSK Signals.
*******************************************************************/
//#define CID_SIMULATION

#include <CidTxCon.h>

#ifdef CID_SIMULATION
 #include <Typedef.h>
#endif


/*
       Cid Data Structure
*/
typedef struct  StructCidTx {
	UCHAR     CidTxState;                   
	uWord16   CidTxFramePtr[CIDTX_STRING_BUFF_LEN];
	uWord16   CidTxFrameLen;
	uWord16   CidTxCurIndex;
	uWord16   PhaseSum;
	uWord16   TimerCntr;
	Word16    CidTxPayLoad[CID_TX_PAY_LOAD_LEN];
    UCHAR     CidTxType; 
	Word16    bCaller;
	BOOL      bVMWI;// Sagem ICC : Bug 3242 2006/01/09
}CidTxType_;
/*DTMF_CLIP FW*/
typedef struct  StructDtmfCid {
	UCHAR    ucDigFrameLen;                   	
	UCHAR    ucDigIndex; 
        UCHAR    ucDigState;
	UCHAR    ucIpcDigCntr;
	UCHAR    ucIpcDigFlag;
	uWord16  aucCidDigStr[50];
}dtmfCidType_;

typedef struct
{
  BOOL  bCACid;
  UCHAR ucDate[8];
  UCHAR ucNumber[50];
  UCHAR ucName[50];
  UCHAR ucVisualInd;
  UCHAR ucMsgIdenti[3];
  UCHAR ucLastMsgCli[20];
  UCHAR ucNoOfMsgs;
  UCHAR ucFlag;

}CidParams_t;

unsigned short getCIDTxPlayCntr(UCHAR ucIntrFlag);
