
/* 
 DtmfrxVar.c
 sivan.nagireddi@analog.com
*/

//>>>>>>------------------------------------------------------->>>>>>
//#define  DTMFRX_SIMULATOR
//>>>>>>------------------------------------------------------->>>>>>


#ifdef DTMFRX_SIMULATOR
 #include "typedef.h"
 #include "HDtmfrxConst.h"
#endif

//----->|||  Dtmfrx DataStructure.
typedef struct DtmfrxVarSt_{


//--> DtmferxFrameCntr.
uWord16 DtmfrxFrame;
uWord16 DtmfrxFrameCntr;
uWord16 ToneOffFrameCntr;

//---> InitFlags.
Word16  DtmfrxQueInitCntr;
Word16 Dtmfrx_reset_on;

//--> Que for DSP_IPC_DTMFRX_QUE
uWord16 QueWtFailCntr; 
Word16  DtmfrxQueWtIndex;
Word16  DtmfrxQueRdIndex;
Word16  DSP2HostDtmfrxQue[DSP2HOST_DTMFRX_QUE_LEN][DSP2HOST_DTMFRX_CMD_LEN];

//---> Tone Properties.
Word16 ToneLevel;
Word16 Dtmfrx_tone_on;  
Word16 ToneOnTimerCnt;  
Word16 Dtmfrx_tone_off;
//---> Tone On to off and vice versa switching properties.
Word16 ToneOFF_2_ON;
Word16 ToneON_2_OFF;
//---> Max Different Digits detected during a Tone-ON
Word16 DtmfrxMaxDiffDigs;


//--> Detected Digit.
Word16 Dtmfrx_DtmfLikelyDig;
Word16 Dtmfrx_digit_op; 

//--> Digit Log.
Word16 DtmfrxDigLog[DTMFRX_DIAL_PAD_LEN][DTMFRX_PARAMTER_LEN];


#if 1 
  //--> Log for Digit History for Debugging purpose.
  Word16 DtmfrxDigHistL[DTMFRX_HISTORY_LEN];
  Word16 DtmfrxEneHistL[DTMFRX_HISTORY_LEN];
  Word16 DtmfrxIpOpdBm[DTMFRX_HISTORY_LEN];

  Word16 DtmfrxRowMax1[DTMFRX_HISTORY_LEN];
  Word16 DtmfrxColMax1[DTMFRX_HISTORY_LEN];
  Word16 DtmfrxRowMax2[DTMFRX_HISTORY_LEN];
  Word16 DtmfrxColMax2[DTMFRX_HISTORY_LEN];
  uWord16 DtmfrxSeqHist[DTMFRX_HISTORY_LEN]; //nov18

  Word16 CurFrameTestResult;
  Word16 DtmfrxTestResult;
  Word16 DtmfrxDigPrev;
#endif
  Word16 Dtmfrx_Rej_on;
  Word16 Dtmfrx_Rej_Flag;
  uWord16 DtmfrxSeqNum; //nov18
  uWord16 SeqNumFlag;
  uWord16 SeqNumRx[9];
  uWord16 SeqNumTx[9];
//------------------------------------------------------------
 } DtmfrxDataSt_;  //---> End of DtmfrxDataStruct_
//------------------------------------------------------------


